#include "version.h"
#include "regmap.h"
#include "map.h"

	.section .init
	.global _start
_start:
	mov	r0, #0x50000000
	orr	r0, r0, #0x00000020
	mov     pc, r0
	nop
	
	.long	VERSION
	nop
	nop
	nop

	mov     r0, #0x0                /* MMU mandatory */
	mcr     p15, 0, r0, c1, c0, 0   /* MMU init */

	mov     r0, #0
	mcr     p15, 0, r0, c7, c7, 0   /* flush v3/v4 cache */
	mcr     p15, 0, r0, c8, c7, 0   /* flush v4 TLB */

	/* DRAM */
	mov	r5, #0x60000000
	mov	r6, #0x90000000
	mov     r7, #0xa0000000

	add     r0, r7, #0x700000       /* mem module */
	mov     r2, #0x1
	str     r2, [r0, #MEM_CTRL]
	mov     r2, #0x6
	str     r2, [r0, #MEM_DYN_REFRESH]
	mov     r2, #0x1
	str     r2, [r0, #MEM_DYN_READ_CFG]
	str     r2, [r0, #MEM_DYN_TRP]
	mov     r2, #0x4
	str     r2, [r0, #MEM_DYN_TRAS]
	mov     r2, #0x1
	str     r2, [r0, #MEM_DYN_TAPR]
	mov     r2, #0x5
	str     r2, [r0, #MEM_DYN_TDAL]
	mov     r2, #0x1
	str     r2, [r0, #MEM_DYN_TWR]
	mov     r2, #0x6
	str     r2, [r0, #MEM_DYN_TRC]
	str     r2, [r0, #MEM_DYN_TRFC]
	mov     r2, #0x1
	str     r2, [r0, #MEM_DYN_TRRD]
	str     r2, [r0, #MEM_DYN_TMRD]

	mov     r1, #0x4000
	orr     r2, r1, #0x680
	str     r2, [r0, #MEM_DYN_CFG_0]
	mov     r4, #0x200
	orr     r4, r4, #0x03
	str     r4, [r0, #MEM_DYN_RAS_CAS_0]
	orr     r2, r1, #0x280
	str     r2, [r0, #MEM_DYN_CFG_1]
	str     r4, [r0, #MEM_DYN_RAS_CAS_1]
	str     r2, [r0, #MEM_DYN_CFG_2]
	str     r4, [r0, #MEM_DYN_RAS_CAS_2]
	str     r2, [r0, #MEM_DYN_CFG_3]
	str     r4, [r0, #MEM_DYN_RAS_CAS_3]

	mov     r2, #0x100
	add     r2, r2, #0x03
	str     r2, [r0, #MEM_DYN_CTRL]
	mov     r2, #0x1
	str     r2, [r0, #MEM_DYN_REFRESH]

	mov     r2, #0xa
	str     r2, [r0, #MEM_STATIC_EXT_WAIT]

	mov     r1, #0x50
_sdram_settle:
	subs    r1, r1, #1
	bne     _sdram_settle

	mov     r2, #0x30
	str     r2, [r0, #MEM_DYN_REFRESH]
	mov     r2, #0x83
	str     r2, [r0, #MEM_DYN_CTRL]

	mov     r2, #0x44000
	ldr     r2, [r2]

	mov     r2, #0x3
	str     r2, [r0, #MEM_DYN_CTRL]
	mov     r1, #0x84000
	orr     r2, r1, #0x680
	str     r2, [r0, #MEM_DYN_CFG_0]
	orr     r2, r1, #0x280
	str     r2, [r0, #MEM_DYN_CFG_1]
	str     r2, [r0, #MEM_DYN_CFG_2]
	str     r2, [r0, #MEM_DYN_CFG_3]

	mov     r2, #0x81
	str     r2, [r0, #MEM_STATIC_CFG_1]
	orr     r2, r2, #0x100
	str     r2, [r0, #MEM_STATIC_CFG_2]
	mov     r2, #0x80
	str     r2, [r0, #MEM_STATIC_CFG_3]
	mov     r2, #0x0
	str     r2, [r0, #MEM_STATIC_WAIT_WEN_1]
	str     r2, [r0, #MEM_STATIC_WAIT_WEN_2]
	str     r2, [r0, #MEM_STATIC_WAIT_WEN_3]
	str     r2, [r0, #MEM_STATIC_WAIT_OEN_1]
	str     r2, [r0, #MEM_STATIC_WAIT_OEN_2]
	str     r2, [r0, #MEM_STATIC_WAIT_OEN_3]
	mov     r2, #0x0a
	str     r2, [r0, #MEM_STATIC_WAIT_RD_1]
	mov	r2, #0x02
	str     r2, [r0, #MEM_STATIC_WAIT_RD_2]
	mov     r1, #0x1f
	str     r1, [r0, #MEM_STATIC_WAIT_RD_3]
	str     r1, [r0, #MEM_STATIC_WAIT_PAGE_1]
	str     r1, [r0, #MEM_STATIC_WAIT_PAGE_2]
	str     r1, [r0, #MEM_STATIC_WAIT_PAGE_3]
	mov     r2, #0x0a
	str     r2, [r0, #MEM_STATIC_WAIT_WR_1]
	mov     r2, #0x02
	str     r2, [r0, #MEM_STATIC_WAIT_WR_2]
	str     r1, [r0, #MEM_STATIC_WAIT_WR_3]
	mov     r2, #0x0F
	str     r2, [r0, #MEM_STATIC_WAIT_TURN_1]
	str     r2, [r0, #MEM_STATIC_WAIT_TURN_2]
	str     r1, [r0, #MEM_STATIC_WAIT_TURN_3]

	/* PLD */
	add	r0, r7, #0x00700000
	
	mov	r2, #0x100
	orr	r2, r2, #0x81
	str	r2, [r0 , #MEM_STATIC_CFG_2]

	/* gpio init */
	add	r0, r6, #0x600000
	
	mov	r1, #0x33000000
	orr	r1, r1, #0x00330000
	orr	r2, r1, #0x00003300
	str	r2, [r0, #BBUS_GPIO_CFG_2]
	orr	r2, r1, #0x00003200
	orr	r2, r2, #0x00000033
	str	r2, [r0, #BBUS_GPIO_CFG_4]

	/* bbus reset */
	mov	r2, #0x0
	str	r2, [r0, #BBUS_MASTER_RESET]

#if 0
	/* AHB Arbiter */
	ldr	r0, =SYS_BRC_0
	ldr	r1, =0x80818082
	str	r1, [r0]
	ldr	r0, =SYS_BRC_1
	ldr	r1, =0x80850000
	str	r1, [r0]
	ldr	r0, =SYS_BRC_2
	mov	r1, #0x00000000
	str	r1, [r0]
	ldr	r0, =SYS_BRC_3
	str	r1, [r0]
	ldr	r0, =SYS_AHB_GEN
	mov	r1, #0x1
	str	r1, [r0]
#endif

	/* uart A */
	add	r0, r6, #0x200000
	
	mov	r2, #0x03000000
	str	r2, [r0, #SER_CTRL_A]

	mov	r2, #0x08000000
	str	r2, [r0, #SER_CTRL_B]

	add	r3, r7, #0x900000
	ldr     r1, [r3, #SYS_PLL]
	tst     r1, #0x02000000
	moveq   r2, #0xc0000000
	addeq   r2, r2, #0x140000
	addeq   r2, r2, #95 /*#0x07*/
	movne   r2, #0x81000000
	addne   r2, r2, #0x19
	str     r2, [r0, #SER_BITRATE]

	mov     r2, #0x80000000
	str     r2, [r0, #SER_RX_BUF_TIMER]

	mov     r2, #0x83000000
	str     r2, [r0, #SER_CTRL_A]

	/* init stack pointer */
	mov	sp, #STACK_START_ADDR

	b	setup

	.section .ram.boot
	.global boot_main
boot_main:
	b	main
	.global boot_ram
boot_ram:
	ldr	r0, =BOOT_RAM_ADDR
	mov	pc, r0

	.global boot_2nd
boot_2nd:
	ldr	r0, =BOOT_2ND_ADDR
	mov	pc, r0
