#include "regmap.h"
#include "map.h"

	.section .init
	.global _start
_start:
	mov     r5, #0x60000000
	mov     r6, #0x90000000
	mov     r7, #0xa0000000
	
	/* PLD */
	add	r0, r7, #0x00700000
	
	mov	r2, #0x100
	orr	r2, r2, #0x81
	str	r2, [r0 , #MEM_STATIC_CFG_2]

	/* gpio init */
	add	r0, r6, #0x600000
	
	mov	r1, #0x33000000
	orr	r1, r1, #0x00330000
	orr	r2, r1, #0x00003300
	str	r2, [r0, #BBUS_GPIO_CFG_2]
	orr	r2, r1, #0x00003200
	orr	r2, r2, #0x00000033
	str	r2, [r0, #BBUS_GPIO_CFG_4]

	/* bbus reset */
	mov	r2, #0x0
	str	r2, [r0, #BBUS_MASTER_RESET]

	/* uart A */
	add	r0, r6, #0x200000
	
	mov	r2, #0x03000000
	str	r2, [r0, #SER_CTRL_A]

	mov	r2, #0x08000000
	str	r2, [r0, #SER_CTRL_B]

	add	r3, r7, #0x900000
	ldr     r1, [r3, #SYS_PLL]
	tst     r1, #0x02000000
	moveq   r2, #0xc0000000
	addeq   r2, r2, #0x140000
	addeq   r2, r2, #95 /*#0x07*/
	movne   r2, #0x81000000
	addne   r2, r2, #0x19
	str     r2, [r0, #SER_BITRATE]

	mov     r2, #0x80000000
	str     r2, [r0, #SER_RX_BUF_TIMER]

	mov     r2, #0x83000000
	str     r2, [r0, #SER_CTRL_A]

	/* init stack pointer */
	mov	sp, #STACK_START_ADDR

	bl	setup
	
	b	main

	.global boot_ram
boot_ram:
	ldr	r0, =BOOT_RAM_ADDR
	mov	pc, r0
	
	.global boot_2nd
boot_2nd:
	ldr	r0, =BOOT_2ND_ADDR
	mov	pc, r0
