
#include "regmap.h"
#include "map.h"
#include "serial.h"
#include "delay.h"

#if 0
void led_control(int mode){
  unsigned long v;
  v = readl(NS_BBUS_GPIO_CONFIG_6) & ~0x00000f00;
  writel(NS_BBUS_GPIO_CONFIG_6, v | 0x00000b00);

  v = readl(NS_BBUS_GPIO_CTRL_2) & ~0x00000400;
  writel(NS_BBUS_GPIO_CTRL_2, v | (mode ? 0x00000400 : 0));  
}
#define led_on() led_control(1)
#define led_off() led_control(0)
#endif

int check_cf(void)
{
  unsigned char status;
  status = readb(REG_MISC(MISC_IDE_STAT));
  if(status & F_MISC_IDE_DETECT){
    /* CF detect */
    return 1;
  }
  return 0;
}

int check_boot(void)
{
  unsigned int status;
  status = readl(REG_BBUS(BBUS_GPIO_STAT_1));
  if(status & 0x10000){
    /* Auto boot mode */
    return 1;
  }
  return 0;
}

extern void boot_ram(void);
extern void boot_2nd(void);

int 
main(int argc, char **argv)
{
  int i;
  int ret;
  char *dst = (char *)BOOT_RAM_ADDR;

  if(check_cf() || check_boot()){
    set_baud(115200);
    boot_2nd();
  }

  putchar('<');
  i = BOOT_RAM_SIZE;
  while(i--){
    ret = getchar(500);
    if(ret < 0){
      goto __boot_2nd;
    }
    *dst++ = (char)(ret & 0xff);
  }
  putchar('>');
  flush();

  boot_ram();
  
 __boot_2nd:
  flush();
  set_baud(115200);
  mdelay(100);
  boot_2nd();

  return 0;
}
